#include <iostream>
#include <memory>
#include <string>
using namespace std;


class MyClass

{
   public:
      MyClass(const char* myString);
      MyClass(const MyClass& orig);
      
      virtual ~MyClass();
      string getMyString() const;
      
   private:
      string myString_;
};

MyClass::MyClass(const char* myString) : myString_(myString)
{
}

MyClass::MyClass(const MyClass& orig) : myString_(orig.myString_)
{
   cerr << "copy constructing " << orig.myString_ << endl;
}

string MyClass::getMyString() const
{
   return myString_;
}

// MyClass* ptr = myclass.clone();
// The caller will have to delete this.
// auto_ptr<MyClass> newPtr(someClass.clone());
shared_ptr<MyClass> MyClass::clone() const
{
   return new MyClass(*this);
}


// a = (b = c);
MyClass& MyClass::operator=(const MyClass& rhs)
{
   //:
   return *this;
}


// In general prefer passing const references to pass-by-value
MyClass doSomething(const MyClass& theClass)
{
   cout << theClass.getMyString() << endl;
   string newString = theClass.getMyString() + string(" - did something");
   MyClass newMyClass(newString.c_str());
   
   return newMyClass;
}

void doAPtrThing(MyClass* theClassPtr)
{
}

MyClass::~MyClass()
{
   cerr << "Hey, I'm deleting my class: " << myString_ << "!" << endl;
}

int main()
{
   {
      const MyClass myClass("my first class");
      auto_ptr<MyClass> ptr(new MyClass("dynamically allocated class"));

      //cout << ptr->getMyString() << endl
      doSomething(*ptr);
      MyClass returnedClass("nothing");
      returnedClass =  doSomething(myClass);
      
      //doAPtrThing(ptr.get());
   }
   
   cin.ignore();
}
